Regular Expressions
Collaboration diagram for Regular Expressions:

## Modules

| Base and Implementation Classes

## Namespaces

| std::regex_constants

## Classes

class | std::basic_regex< typename, typename >
class | std::match_results< typename, typename >
class | std::regex_error
class | std::regex_iterator< _Bi_iter, _Ch_type, _Rx_traits >
class | std::regex_token_iterator< _Bi_iter, _Ch_type, _Rx_traits >
struct | std::regex_traits< _Ch_type >
class | std::sub_match< _BiIter >

## Typedefs

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
using | std::__sub_match_string = basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc >
typedef match_results< const char * > | std::cmatch
typedef regex_iterator< const char * > | std::cregex_iterator
typedef regex_token_iterator < const char * > | std::cregex_token_iterator
typedef sub_match< const char * > | std::csub_match
typedef basic_regex< char > | std::regex
typedef match_results < string::const_iterator > | std::smatch
typedef regex_iterator < string::const_iterator > | std::sregex_iterator
typedef regex_token_iterator < string::const_iterator > | std::sregex_token_iterator
typedef sub_match < string::const_iterator > | std::ssub_match
typedef match_results< const wchar_t * > | std::wcmatch
typedef regex_iterator< const wchar_t * > | std::wcregex_iterator
typedef regex_token_iterator < const wchar_t * > | std::wcregex_token_iterator
typedef sub_match< const wchar_t * > | std::wcsub_match
typedef basic_regex< wchar_t > | std::wregex
typedef match_results < wstring::const_iterator > | std::wsmatch
typedef regex_iterator < wstring::const_iterator > | std::wsregex_iterator
typedef regex_token_iterator < wstring::const_iterator > | std::wsregex_token_iterator
typedef sub_match < wstring::const_iterator > | std::wssub_match

## Functions

template<typename _Bi_iter >
const sub_match< _Bi_iter > & | std::__unmatched_sub ()
template<typename _BiIter >
bool | std::operator!= (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator!= (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator!= (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator!= (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator!= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator!= (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator!= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _Bi_iter , class _Alloc >
bool | std::operator!= (const match_results< _Bi_iter, _Alloc > &__m1, const match_results< _Bi_iter, _Alloc > &__m2)
template<typename _BiIter >
bool | std::operator< (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator< (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >
bool | std::operator< (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator< (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator< (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator< (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator< (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _Ch_type , typename _Ch_traits , typename _Bi_iter >
basic_ostream< _Ch_type, _Ch_traits > & | std::operator<< (basic_ostream< _Ch_type, _Ch_traits > &__os, const sub_match< _Bi_iter > &__m)
template<typename _BiIter >
bool | std::operator<= (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator<= (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >
bool | std::operator<= (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator<= (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator<= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator<= (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator<= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _BiIter >
bool | std::operator== (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator== (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator== (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator== (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator== (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator== (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator== (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _Bi_iter , typename _Alloc >
bool | std::operator== (const match_results< _Bi_iter, _Alloc > &__m1, const match_results< _Bi_iter, _Alloc > &__m2)
template<typename _BiIter >
bool | std::operator> (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator> (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >
bool | std::operator> (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator> (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator> (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator> (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator> (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _BiIter >
bool | std::operator>= (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >
bool | std::operator>= (const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >
bool | std::operator>= (const sub_match< _Bi_iter > &__lhs, const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > &__rhs)
template<typename _Bi_iter >
bool | std::operator>= (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator>= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
template<typename _Bi_iter >
bool | std::operator>= (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
template<typename _Bi_iter >
bool | std::operator>= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
template<typename _Ch_type , typename _Rx_traits >
void | std::swap (basic_regex< _Ch_type, _Rx_traits > &__lhs, basic_regex< _Ch_type, _Rx_traits > &__rhs)
template<typename _Bi_iter , typename _Alloc >
void | std::swap (match_results< _Bi_iter, _Alloc > &__lhs, match_results< _Bi_iter, _Alloc > &__rhs)

## Matching, Searching, and Replacing

template<typename _Bi_iter , typename _Alloc , typename _Ch_type , typename _Rx_traits >
bool | std::regex_match (_Bi_iter __s, _Bi_iter __e, match_results< _Bi_iter, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits >
bool | std::regex_match (_Bi_iter __first, _Bi_iter __last, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Ch_type , typename _Alloc , typename _Rx_traits >
bool | std::regex_match (const _Ch_type *__s, match_results< const _Ch_type *, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __f=regex_constants::match_default)
template<typename _Ch_traits , typename _Ch_alloc , typename _Alloc , typename _Ch_type , typename _Rx_traits >
bool | std::regex_match (const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > &__s, match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Ch_type , class _Rx_traits >
bool | std::regex_match (const _Ch_type *__s, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __f=regex_constants::match_default)
template<typename _Ch_traits , typename _Str_allocator , typename _Ch_type , typename _Rx_traits >
bool | std::regex_match (const basic_string< _Ch_type, _Ch_traits, _Str_allocator > &__s, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Bi_iter , typename _Alloc , typename _Ch_type , typename _Rx_traits >
bool | std::regex_search (_Bi_iter __s, _Bi_iter __e, match_results< _Bi_iter, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits >
bool | std::regex_search (_Bi_iter __first, _Bi_iter __last, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Ch_type , class _Alloc , class _Rx_traits >
bool | std::regex_search (const _Ch_type *__s, match_results< const _Ch_type *, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __f=regex_constants::match_default)
template<typename _Ch_type , typename _Rx_traits >
bool | std::regex_search (const _Ch_type *__s, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __f=regex_constants::match_default)
template<typename _Ch_traits , typename _String_allocator , typename _Ch_type , typename _Rx_traits >
bool | std::regex_search (const basic_string< _Ch_type, _Ch_traits, _String_allocator > &__s, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Ch_traits , typename _Ch_alloc , typename _Alloc , typename _Ch_type , typename _Rx_traits >
bool | std::regex_search (const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > &__s, match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Alloc > &__m, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __f=regex_constants::match_default)
template<typename _Out_iter , typename _Bi_iter , typename _Rx_traits , typename _Ch_type , typename _St , typename _Sa >
_Out_iter | std::regex_replace (_Out_iter __out, _Bi_iter __first, _Bi_iter __last, const basic_regex< _Ch_type, _Rx_traits > &__e, const basic_string< _Ch_type, _St, _Sa > &__fmt, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Out_iter , typename _Bi_iter , typename _Rx_traits , typename _Ch_type >
_Out_iter | std::regex_replace (_Out_iter __out, _Bi_iter __first, _Bi_iter __last, const basic_regex< _Ch_type, _Rx_traits > &__e, const _Ch_type *__fmt, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Rx_traits , typename _Ch_type , typename _St , typename _Sa , typename _Fst , typename _Fsa >
basic_string< _Ch_type, _St, _Sa > | std::regex_replace (const basic_string< _Ch_type, _St, _Sa > &__s, const basic_regex< _Ch_type, _Rx_traits > &__e, const basic_string< _Ch_type, _Fst, _Fsa > &__fmt, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Rx_traits , typename _Ch_type , typename _St , typename _Sa >
basic_string< _Ch_type, _St, _Sa > | std::regex_replace (const basic_string< _Ch_type, _St, _Sa > &__s, const basic_regex< _Ch_type, _Rx_traits > &__e, const _Ch_type *__fmt, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Rx_traits , typename _Ch_type , typename _St , typename _Sa >
basic_string< _Ch_type > | std::regex_replace (const _Ch_type *__s, const basic_regex< _Ch_type, _Rx_traits > &__e, const basic_string< _Ch_type, _St, _Sa > &__fmt, regex_constants::match_flag_type __flags=regex_constants::match_default)
template<typename _Rx_traits , typename _Ch_type >
basic_string< _Ch_type > | std::regex_replace (const _Ch_type *__s, const basic_regex< _Ch_type, _Rx_traits > &__e, const _Ch_type *__fmt, regex_constants::match_flag_type __flags=regex_constants::match_default)

## Detailed Description

A facility for performing regular expression pattern matching.

## Typedef Documentation

typedef regex_token_iterator<const char*> std::cregex_token_iterator

Token iterator for C-style NULL-terminated strings.

Definition at line 2704 of file regex.h.

typedef sub_match<const char*> std::csub_match

Standard regex submatch over a C-style null-terminated string.

Definition at line 912 of file regex.h.

typedef basic_regex<char> std::regex

Standard regular expressions.

Definition at line 784 of file regex.h.

typedef regex_token_iterator<string::const_iterator> std::sregex_token_iterator

Token iterator for standard strings.

Definition at line 2707 of file regex.h.

typedef sub_match<string::const_iterator> std::ssub_match

Standard regex submatch over a standard string.

Definition at line 915 of file regex.h.

typedef regex_token_iterator<const wchar_t*> std::wcregex_token_iterator

Token iterator for C-style NULL-terminated wide strings.

Definition at line 2711 of file regex.h.

typedef sub_match<const wchar_t*> std::wcsub_match

Regex submatch over a C-style null-terminated wide string.

Definition at line 919 of file regex.h.

typedef basic_regex<wchar_t> std::wregex

Standard wide-character regular expressions.

Definition at line 788 of file regex.h.

typedef regex_token_iterator<wstring::const_iterator> std::wsregex_token_iterator

Token iterator for standard wide-character strings.

Definition at line 2714 of file regex.h.

typedef sub_match<wstring::const_iterator> std::wssub_match

Regex submatch over a standard wide string.

Definition at line 922 of file regex.h.

## Function Documentation

template<typename _BiIter >

bool std::operator!= | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the inequivalence of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 946 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator!= | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the inequivalence of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1021 of file regex.h.

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator!= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the inequivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1095 of file regex.h.

template<typename _Bi_iter >

bool std::operator!= | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the inequivalence of an iterator value and a regular expression submatch.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1169 of file regex.h.

template<typename _Bi_iter >

bool std::operator!= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the inequivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A pointer to a string.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1243 of file regex.h.

template<typename _Bi_iter >

bool std::operator!= | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the inequivalence of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1320 of file regex.h.

template<typename _Bi_iter >

bool std::operator!= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the inequivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs is not equivalent to __rhs, false otherwise.

Definition at line 1400 of file regex.h.

template<typename _Bi_iter , class _Alloc >

bool std::operator!= | ( | const match_results< _Bi_iter, _Alloc > & | __m1,
|  | const match_results< _Bi_iter, _Alloc > & | __m2
| ) |  |

inline

Compares two match_results for inequality.

Returns
  true if the two objects do not refer to the same match, false otherwise.

Definition at line 1928 of file regex.h.

template<typename _BiIter >

bool std::operator< | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the ordering of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 957 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator< | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1033 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator< | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1107 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::compare().

template<typename _Bi_iter >

bool std::operator< | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1181 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator< | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1255 of file regex.h.

template<typename _Bi_iter >

bool std::operator< | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1332 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator< | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs precedes __rhs, false otherwise.

Definition at line 1412 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Ch_type , typename _Ch_traits , typename _Bi_iter >

basic_ostream<_Ch_type, _Ch_traits>& std::operator<< | ( | basic_ostream< _Ch_type, _Ch_traits > & | __os,
|  | const sub_match< _Bi_iter > & | __m
| ) |  |

inline

Inserts a matched string into an output stream.

Parameters

  __os | The output stream.
  __m | A submatch string.

Returns
  the output stream with the submatch string inserted.

Definition at line 1466 of file regex.h.

References std::sub_match< _BiIter >::str().

template<typename _BiIter >

bool std::operator<= | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the ordering of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 968 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator<= | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1069 of file regex.h.

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator<= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1143 of file regex.h.

template<typename _Bi_iter >

bool std::operator<= | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1217 of file regex.h.

template<typename _Bi_iter >

bool std::operator<= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1291 of file regex.h.

template<typename _Bi_iter >

bool std::operator<= | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1371 of file regex.h.

template<typename _Bi_iter >

bool std::operator<= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs does not succeed __rhs, false otherwise.

Definition at line 1451 of file regex.h.

template<typename _BiIter >

bool std::operator== | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the equivalence of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 935 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator== | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the equivalence of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1008 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str(), and std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator== | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the equivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1082 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str(), and std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator== | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the equivalence of a C string and a regular expression submatch.

Parameters

  __lhs | A C string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1156 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator== | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the equivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A pointer to a string?

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1230 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator== | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the equivalence of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1304 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator== | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the equivalence of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs is equivalent to __rhs, false otherwise.

Definition at line 1384 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Alloc >

bool std::operator== | ( | const match_results< _Bi_iter, _Alloc > & | __m1,
|  | const match_results< _Bi_iter, _Alloc > & | __m2
| ) |  |

inline

Compares two match_results for equality.

Returns
  true if the two objects refer to the same match, false otherwise.

Definition at line 1904 of file regex.h.

References std::equal().

template<typename _BiIter >

bool std::operator> | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the ordering of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 990 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator> | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1045 of file regex.h.

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator> | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1119 of file regex.h.

template<typename _Bi_iter >

bool std::operator> | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1193 of file regex.h.

template<typename _Bi_iter >

bool std::operator> | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1267 of file regex.h.

template<typename _Bi_iter >

bool std::operator> | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1347 of file regex.h.

template<typename _Bi_iter >

bool std::operator> | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs succeeds __rhs, false otherwise.

Definition at line 1427 of file regex.h.

template<typename _BiIter >

bool std::operator>= | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs
| ) |  |

inline

Tests the ordering of two regular expression submatches.

Parameters

  __lhs | First regular expression submatch.
  __rhs | Second regular expression submatch.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 979 of file regex.h.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator>= | ( | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1057 of file regex.h.

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator>= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const __sub_match_string< _Bi_iter, _Ch_traits, _Ch_alloc > & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1131 of file regex.h.

template<typename _Bi_iter >

bool std::operator>= | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1205 of file regex.h.

template<typename _Bi_iter >

bool std::operator>= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A string.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1279 of file regex.h.

template<typename _Bi_iter >

bool std::operator>= | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs
| ) |  |

inline

Tests the ordering of a string and a regular expression submatch.

Parameters

  __lhs | A string.
  __rhs | A regular expression submatch.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1359 of file regex.h.

template<typename _Bi_iter >

bool std::operator>= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs
| ) |  |

inline

Tests the ordering of a regular expression submatch and a string.

Parameters

  __lhs | A regular expression submatch.
  __rhs | A const string reference.

Returns
  true if __lhs does not precede __rhs, false otherwise.

Definition at line 1439 of file regex.h.

template<typename _Bi_iter , typename _Alloc , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | _Bi_iter | __s,
|  | _Bi_iter | __e,
|  | match_results< _Bi_iter, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Determines if there is a match between the regular expression `e` and all of the character sequence [first, last).

Parameters

  __s | Start of the character sequence to match.
  __e | One-past-the-end of the character sequence to match.
  __m | The match results.
  __re | The regular expression.
  __flags | Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 1970 of file regex.h.

Referenced by std::regex_match().

template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Indicates if there is a match between the regular expression `e` and all of the character sequence [first, last).

Parameters

  __first | Beginning of the character sequence to match.
  __last | One-past-the-end of the character sequence to match.
  __re | The regular expression.
  __flags | Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 1998 of file regex.h.

References std::regex_match().

template<typename _Ch_type , typename _Alloc , typename _Rx_traits >

bool std::regex_match | ( | const _Ch_type * | __s,
|  | match_results< const _Ch_type *, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default`
| ) |  |

inline

Determines if there is a match between the regular expression `e` and a C-style null-terminated string.

Parameters

  __s | The C-style null-terminated string to match.
  __m | The match results.
  __re | The regular expression.
  __f | Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 2023 of file regex.h.

References std::regex_match().

template<typename _Ch_traits , typename _Ch_alloc , typename _Alloc , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > & | __s,
|  | match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Determines if there is a match between the regular expression `e` and a string.

Parameters

  __s | The string to match.
  __m | The match results.
  __re | The regular expression.
  __flags | Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 2047 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_match().

template<typename _Ch_type , class _Rx_traits >

bool std::regex_match | ( | const _Ch_type * | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default`
| ) |  |

inline

Indicates if there is a match between the regular expression `e` and a C-style null-terminated string.

Parameters

  __s | The C-style null-terminated string to match.
  __re | The regular expression.
  __f | Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 2070 of file regex.h.

References std::regex_match().

template<typename _Ch_traits , typename _Str_allocator , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | const basic_string< _Ch_type, _Ch_traits, _Str_allocator > & | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Indicates if there is a match between the regular expression `e` and a string.

Parameters

  __s | [IN] The string to match.
  __re | [IN] The regular expression.
  __flags | [IN] Controls how the regular expression is matched.

Return values

  true | A match exists.
  false | Otherwise.

Exceptions

  an | exception of type regex_error.

Definition at line 2092 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_match().

template<typename _Out_iter , typename _Bi_iter , typename _Rx_traits , typename _Ch_type , typename _St , typename _Sa >

_Out_iter std::regex_replace | ( | _Out_iter | __out,
|  | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | const basic_string< _Ch_type, _St, _Sa > & | __fmt,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Search for a regular expression within a range for multiple times, and replace the matched parts through filling a format string.

Parameters

  __out | [OUT] The output iterator.
  __first | [IN] The start of the string to search.
  __last | [IN] One-past-the-end of the string to search.
  __e | [IN] The regular expression to search for.
  __fmt | [IN] The format string.
  __flags | [IN] Search and replace policy flags.

Returns
  __out

Exceptions

  an | exception of type regex_error.

Definition at line 2249 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str().

Referenced by std::regex_replace().

template<typename _Out_iter , typename _Bi_iter , typename _Rx_traits , typename _Ch_type >

_Out_iter std::regex_replace | ( | _Out_iter | __out,
|  | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | const _Ch_type * | __fmt,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

Search for a regular expression within a range for multiple times, and replace the matched parts through filling a format C-string.

Parameters

  __out | [OUT] The output iterator.
  __first | [IN] The start of the string to search.
  __last | [IN] One-past-the-end of the string to search.
  __e | [IN] The regular expression to search for.
  __fmt | [IN] The format C-string.
  __flags | [IN] Search and replace policy flags.

Returns
  __out

Exceptions

  an | exception of type regex_error.

Definition at line 504 of file regex.tcc.

References std::pair< _T1, _T2 >::first, std::regex_constants::format_first_only, std::regex_constants::format_no_copy, and std::pair< _T1, _T2 >::second.

template<typename _Rx_traits , typename _Ch_type , typename _St , typename _Sa , typename _Fst , typename _Fsa >

basic_string<_Ch_type, _St, _Sa> std::regex_replace | ( | const basic_string< _Ch_type, _St, _Sa > & | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | const basic_string< _Ch_type, _Fst, _Fsa > & | __fmt,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Search for a regular expression within a string for multiple times, and replace the matched parts through filling a format string.

Parameters

  __s | [IN] The string to search and replace.
  __e | [IN] The regular expression to search for.
  __fmt | [IN] The format string.
  __flags | [IN] Search and replace policy flags.

Returns
  The string after replacing.

Exceptions

  an | exception of type regex_error.

Definition at line 2294 of file regex.h.

References std::back_inserter(), std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_replace().

template<typename _Rx_traits , typename _Ch_type , typename _St , typename _Sa >

basic_string<_Ch_type, _St, _Sa> std::regex_replace | ( | const basic_string< _Ch_type, _St, _Sa > & | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | const _Ch_type * | __fmt,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Search for a regular expression within a string for multiple times, and replace the matched parts through filling a format C-string.

Parameters

  __s | [IN] The string to search and replace.
  __e | [IN] The regular expression to search for.
  __fmt | [IN] The format C-string.
  __flags | [IN] Search and replace policy flags.

Returns
  The string after replacing.

Exceptions

  an | exception of type regex_error.

Definition at line 2320 of file regex.h.

References std::back_inserter(), std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_replace().

template<typename _Rx_traits , typename _Ch_type , typename _St , typename _Sa >

basic_string<_Ch_type> std::regex_replace | ( | const _Ch_type * | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | const basic_string< _Ch_type, _St, _Sa > & | __fmt,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Search for a regular expression within a C-string for multiple times, and replace the matched parts through filling a format string.

Parameters

  __s | [IN] The C-string to search and replace.
  __e | [IN] The regular expression to search for.
  __fmt | [IN] The format string.
  __flags | [IN] Search and replace policy flags.

Returns
  The string after replacing.

Exceptions

  an | exception of type regex_error.

Definition at line 2346 of file regex.h.

References std::back_inserter(), and std::regex_replace().

template<typename _Rx_traits , typename _Ch_type >

basic_string<_Ch_type> std::regex_replace | ( | const _Ch_type * | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | const _Ch_type * | __fmt,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Search for a regular expression within a C-string for multiple times, and replace the matched parts through filling a format C-string.

Parameters

  __s | [IN] The C-string to search and replace.
  __e | [IN] The regular expression to search for.
  __fmt | [IN] The format C-string.
  __flags | [IN] Search and replace policy flags.

Returns
  The string after replacing.

Exceptions

  an | exception of type regex_error.

Definition at line 2372 of file regex.h.

References std::back_inserter(), and std::regex_replace().

template<typename _Bi_iter , typename _Alloc , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | _Bi_iter | __s,
|  | _Bi_iter | __e,
|  | match_results< _Bi_iter, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a range.

Parameters

  __first | [IN] The start of the string to search.
  __last | [IN] One-past-the-end of the string to search.
  __m | [OUT] The match results.
  __re | [IN] The regular expression to search for.
  __flags | [IN] Search policy flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string, the content of m is undefined.

Exceptions

  an | exception of type regex_error.

Definition at line 2115 of file regex.h.

Referenced by std::regex_iterator< _Bi_iter, _Ch_type, _Rx_traits >::operator++(), std::regex_iterator< _Bi_iter, _Ch_type, _Rx_traits >::regex_iterator(), and std::regex_search().

template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a range.

Parameters

  __first | [IN] The start of the string to search.
  __last | [IN] One-past-the-end of the string to search.
  __re | [IN] The regular expression to search for.
  __flags | [IN] Search policy flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string.

Exceptions

  an | exception of type regex_error.

Definition at line 2139 of file regex.h.

References std::regex_search().

template<typename _Ch_type , class _Alloc , class _Rx_traits >

bool std::regex_search | ( | const _Ch_type * | __s,
|  | match_results< const _Ch_type *, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a C-string.

Parameters

  __s | [IN] A C-string to search for the regex.
  __m | [OUT] The set of regex matches.
  __e | [IN] The regex to search for in `s`.
  __f | [IN] The search flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string, the content of m is undefined.

Exceptions

  an | exception of type regex_error.

Definition at line 2162 of file regex.h.

References std::regex_search().

template<typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | const _Ch_type * | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a C-string.

Parameters

  __s | [IN] The C-string to search.
  __e | [IN] The regular expression to search for.
  __f | [IN] Search policy flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string.

Exceptions

  an | exception of type regex_error.

Definition at line 2181 of file regex.h.

References std::regex_search().

template<typename _Ch_traits , typename _String_allocator , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | const basic_string< _Ch_type, _Ch_traits, _String_allocator > & | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a string.

Parameters

  __s | [IN] The string to search.
  __e | [IN] The regular expression to search for.
  __flags | [IN] Search policy flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string.

Exceptions

  an | exception of type regex_error.

Definition at line 2200 of file regex.h.

References std::regex_search().

template<typename _Ch_traits , typename _Ch_alloc , typename _Alloc , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > & | __s,
|  | match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Alloc > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default`
| ) |  |

inline

Searches for a regular expression within a string.

Parameters

  __s | [IN] A C++ string to search for the regex.
  __m | [OUT] The set of regex matches.
  __e | [IN] The regex to search for in `s`.
  __f | [IN] The search flags.

Return values

  true | A match was found within the string.
  false | No match was found within the string, the content of m is undefined.

Exceptions

  an | exception of type regex_error.

Definition at line 2223 of file regex.h.

References std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_search().

template<typename _Ch_type , typename _Rx_traits >

void std::swap | ( | basic_regex< _Ch_type, _Rx_traits > & | __lhs,
|  | basic_regex< _Ch_type, _Rx_traits > & | __rhs
| ) |  |

inline

Swaps the contents of two regular expression objects.

Parameters

  __lhs | First regular expression.
  __rhs | Second regular expression.

Definition at line 800 of file regex.h.

template<typename _Bi_iter , typename _Alloc >

void std::swap | ( | match_results< _Bi_iter, _Alloc > & | __lhs,
|  | match_results< _Bi_iter, _Alloc > & | __rhs
| ) |  |

inline

Swaps two match results.

Parameters

  __lhs | A match result.
  __rhs | A match result.

The contents of the two match_results objects are swapped.

Definition at line 1942 of file regex.h.